/*

====C_wrapper_i(parsed_code)====

Returns a C program which, when compiled and linked, wraps the contents of ''parsed_code''
Used by C_wrapper.

*/

C.C_wrapper_i=function(parsed_code, default_dl) {
	var ret='';
	var fw='';
	var hdr='';
	var foot='';

	hdr+='#ifdef _WIN32\n';
	hdr+='#define JS_DLL_CALLBACK __cdecl\n';
	hdr+='#  if defined(__MWERKS__) || defined(__GNUC__)\n';
	hdr+='#    define JS_IMPORT_API(__x)      __x\n';
	hdr+='#  else\n';
	hdr+='#    define JS_IMPORT_API(__x)      __declspec(dllimport) __x\n';
	hdr+='#  endif\n';
	hdr+='#else\n';
	hdr+='#define JS_DLL_CALLBACK\n';
	hdr+='#define JS_IMPORT_API(__x) __x\n';
	hdr+='#endif\n';
	hdr+='#define JS_PUBLIC_API(__x) JS_IMPORT_API(__x)\n';
	hdr+='#define JS_FALSE 0\n';
	hdr+='#define JS_TRUE 1\n';
	hdr+='#define JSPROP_ENUMERATE        0x01    /* property is visible to for/in loop */\n'
	hdr+='#define OBJECT_TO_JSVAL(obj) ((jsval)(obj))\n';
	hdr+='#define JS_BIT(n) ((JSUint32)1 << (n))\n';
	hdr+='#define JS_BITMASK(n) (JS_BIT(n) - 1)\n';
	hdr+='#define JSVAL_TAGBITS           3\n';
	hdr+='#define JSVAL_TAGMASK           JS_BITMASK(JSVAL_TAGBITS)\n';
	hdr+='#define JSVAL_CLRTAG(v)         ((v) & ~(jsval)JSVAL_TAGMASK)\n';
	hdr+='#define JSVAL_TO_GCTHING(v)     ((void *)JSVAL_CLRTAG(v))\n';
	hdr+='#define JSVAL_TO_OBJECT(v)      ((JSObject *)JSVAL_TO_GCTHING(v))\n';
	hdr+='#define JSPROP_ENUMERATE		  0x01\n';
	hdr+='#define JSVAL_NULL              OBJECT_TO_JSVAL(0)\n';
	hdr+='#define JSVAL_OBJECT            0x0     /* untagged reference to object */\n';
	hdr+='#define JSVAL_INT               0x1     /* tagged 31-bit integer value */\n';
	hdr+='#define JSVAL_STRING            0x4     /* tagged reference to string */\n';
	hdr+='#define JSVAL_SETTAG(v,t)       ((v) | (t))\n';
	hdr+='#define STRING_TO_JSVAL(str) JSVAL_SETTAG((jsval)(str), JSVAL_STRING)\n';
	hdr+='#define INT_TO_JSVAL(i)         (((jsval)(i) << 1) | JSVAL_INT)\n';
	hdr+='#define JSVAL_INT_POW2(n)       ((jsval)1 << (n))\n';
	hdr+='#define JSVAL_VOID              INT_TO_JSVAL(0 - JSVAL_INT_POW2(30))\n';
	hdr+='#define JSVAL_TAG(v)            ((v) & JSVAL_TAGMASK)\n';
	hdr+='#define JSVAL_IS_OBJECT(v)      (JSVAL_TAG(v) == JSVAL_OBJECT)\n';
	hdr+='\n';
	hdr+='typedef struct JSContext JSContext;\n';
	hdr+='typedef struct JSObject JSObject;\n';
	hdr+='typedef struct JSString JSString;\n';
	hdr+='typedef struct JSClass JSClass;\n';
	hdr+='typedef unsigned int JSUint32;\n';
	hdr+='typedef JSUint32 uintN;\n';
	hdr+='typedef unsigned int jsval;\n';
	hdr+='typedef unsigned long int size_t;\n';
	hdr+='typedef unsigned int JSBool;\n';
	hdr+='\n';
	hdr+='struct JSX_pointer;\n';
	hdr+='\n';
	hdr+='typedef JSBool (* JSNative)(JSContext *cx, JSObject *obj, uintN argc,\n';
        hdr+='                                            jsval *argv, jsval *rval);\n';
	hdr+='\n';
	hdr+='extern JS_PUBLIC_API(void *) JS_malloc(JSContext *cx, size_t nbytes);\n';
	hdr+='extern JS_PUBLIC_API(JSBool) JS_SetProperty(JSContext *cx, JSObject *obj, const char *name, jsval *vp);\n';
	hdr+='extern JS_PUBLIC_API(JSBool) JS_EvaluateScript(JSContext *cx, JSObject *obj, const char *bytes, uintN length, const char *filename, uintN lineno, jsval *rval);\n';
	hdr+='extern JS_PUBLIC_API(JSObject *) JS_DefineObject(JSContext *cx, JSObject *obj, const char *name, JSClass *clasp, JSObject *proto, uintN flags);\n';
	hdr+='extern JS_PUBLIC_API(JSString *) JS_NewStringCopyZ(JSContext *cx, const char *s);\n';
	hdr+='extern JS_PUBLIC_API(JSBool) JS_DefineFunction(JSContext *cx, JSObject *obj, const char *name, JSNative call,\n';
	hdr+='                                               uintN nargs, uintN attrs);\n';
	hdr+='extern JS_PUBLIC_API(JSBool) JS_ConvertArguments(JSContext *cx, uintN argc, jsval *argv, const char *format,\n';
	hdr+='                    ...);\n';
	hdr+='\n';
	hdr+='extern JS_PUBLIC_API(JSObject *) JSX_pointer_new_x(JSContext *cx, JSObject *object, char *s, JSObject *dl);\n';
	hdr+='extern JS_PUBLIC_API(JSObject *) JSX_Type_new_x(JSContext *cx, JSObject *this, JSObject *object, char *s);\n';
	hdr+='extern JS_PUBLIC_API(struct JSX_pointer *) JSX_pointer_new_x_x(JSContext *cx, JSObject *obj, char *s, JSObject *dl);\n';
	hdr+='typedef JSBool (*tJSEXT_dl_new)(JSContext *, JSObject *, char *filename, jsval *rval);\n';
	hdr+='#ifdef _WIN32\n';
	hdr+='extern JS_PUBLIC_API(void *) JSX_globalsym(JSContext *,JSObject *dl, const char *symbol);\n';
	hdr+='tJSEXT_dl_new pJSEXT_dl_new=0;\n';
	hdr+='#else\n';
	hdr+='extern JS_PUBLIC_API(JSBool) JSEXT_dl_newA(JSContext *cx, JSObject *obj, char *filename, jsval *rval);\n';
	hdr+='tJSEXT_dl_new pJSEXT_dl_new=&JSEXT_dl_newA;\n';
	hdr+='#endif\n';
	hdr+='\n';

	ret+='#ifdef _WIN32\n';
	ret+='__declspec(dllexport)\n';
	ret+='#endif\n';
	ret+='JSBool\n';
	ret+='JSEXT_init(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {\n';


	ret+='JSObject *_struct;\n';
	ret+='jsval _structval;\n';
	ret+='JSObject *tmpobj=0;\n';
	ret+='jsval tmpval=0;\n';
	ret+='JSBool tmpbool;\n';
	ret+='  char *filename;\n';

	ret+='#ifdef _WIN32\n';
	ret+='pJSEXT_dl_new=(tJSEXT_dl_new) JSX_globalsym(cx, 0, "JSEXT_dl_newA");\n';
	ret+='#endif\n';
	ret+='JS_GetProperty(cx, obj, "struct", &_structval);\n';

	ret+='if (_structval==JSVAL_VOID || !JSVAL_IS_OBJECT(_structval)) {\n';
	ret+='  _struct=JS_DefineObject(cx, obj, "struct", 0, 0, JSPROP_ENUMERATE);\n'
	ret+='  _structval=OBJECT_TO_JSVAL(_struct);\n';
	ret+='} else {\n';
	ret+='  _struct=JSVAL_TO_OBJECT(_structval);\n';
	ret+='}\n';

	if (default_dl!=undefined) {
			hdr+='static JSObject *dl0=0;\n';

			ret+='if (!dl0) {\n';
			if (os.isrelative(default_dl.filename[0])) {
				// relative path must be made relative to arg[0]'s path
        ret+='  if (JS_ConvertArguments(cx, argc, argv, "s", &filename)) {\n';
        ret+='    char *p,*t;\n'
        ret+='    char *s=filename,*c=filename;\n';
        ret+='    while(*c) c++;\n';
		ret+='	  while (c>filename && c[-1]!='+os.sep.charCodeAt(0)+') c--;\n';
		ret+='    t=p=JS_malloc(cx, c-filename+'+(default_dl.filename.length+1)+');\n';
        ret+='    while(s<c) *(t++)=*(s++);\n';
		ret+='    s='+chopstring(default_dl.filename)+';\n';
        ret+='    while(*s) *(t++)=*(s++);\n';
		ret+='    *t=0;\n';
		ret+='    (*pJSEXT_dl_new)(cx, obj, p, &tmpval);\n';
        ret+='    JS_free(cx,p);\n';
        ret+='    }\n';

			} else {
				// absolute path
				ret+='  (*pJSEXT_dl_new)(cx, obj, "'+default_dl.filename+'", &tmpval);\n';
			}
			ret+='  dl0=JSVAL_TO_OBJECT(tmpval);\n';
			ret+='  if (dl0) JS_AddRoot(cx, (void *)&dl0);\n';
			ret+='}\n';

			foot+='//if (dl0) JS_RemoveRoot(cx, (void *)&dl0);\n';
	}

        for (var name in parsed_code.structs) try {
		var obj=parsed_code.structs[name];
                ret+='tmpval=OBJECT_TO_JSVAL(JSX_Type_new_x(cx, obj, 0, '+chopstring(" 0 "+parsed_code.structstring(obj))+'));\n';
                ret+='JS_SetProperty(cx, _struct, "'+name+'", &tmpval);\n';
        } catch (x) {
		print("struct ",name,"\n");
		print(obj,"\n");
		throw(x);
        }

	for (var name in parsed_code.enums) try {
		var obj=parsed_code.enums[name];
		var defs=parsed_code.enumvals(obj);
		for (var i in defs) {
			ret+='tmpval=INT_TO_JSVAL('+defs[i]+');\n';
			ret+='JS_SetProperty(cx, obj, "'+i+'", &tmpval);\n';
		}
	} catch(x) {
		print("enum ",name,"\n");
		throw(x);
	}

	for (var index in parsed_code.dls) try {
		if (typeof(parsed_code.dls[index])=="string") {
			hdr+='static JSObject *dl'+index+'=0;\n';

			ret+='if (!dl'+index+') {\n';
			ret+='  (*pJSEXT_dl_new)(cx, obj, "'+parsed_code.dls[index]+'", &tmpval);\n';
			ret+='  dl'+index+'=JSVAL_TO_OBJECT(tmpval);\n';
			ret+='  if (dl'+index+') JS_AddRoot(cx, (void *)&dl'+index+');\n';
			ret+='}\n';

			foot+='//if (dl'+index+') JS_RemoveRoot(cx, (void *)&dl'+index+');\n';
		}
	} catch(x) {
		print("dl ",parsed_code.dls[index],"\n");
		throw(x);
	}

	parsed_code.loaddls(default_dl);

    var prevdecl={};
    var testobj={};
    for (var index in parsed_code.ptrs) try {

		var obj=parsed_code.ptrs[index];
		var type=parsed_code.type(obj);

		if (prevdecl[type.ident]==undefined) {
			prevdecl[type.ident]=true;

			var dlindex=parsed_code.link(type.ident);
			if (dlindex!=undefined) { // managed to link
				if (typeof(parsed_code.dls[dlindex])=="string")
					var currentdl="dl"+dlindex; // loaded dl
				else if (parsed_code.dls[dlindex]==0)
					var currentdl="0"; // main
				else
					var currentdl="dl0"; // default

				if (type.type=="function") {
					ret+='JS_DefineFunction(cx, obj, "'+type.ident+'", JSXC_'+type.ident+', '+type.params.length+', 0); // '+currentdl+'\n';
					ret+='JS_SetPropertyAttributes(cx, obj, "'+type.ident+'", JSPROP_ENUMERATE, &tmpbool);\n';

					fw+=funcwrapper(type.ident, obj, currentdl);
				} else {
			        ret+='tmpval=OBJECT_TO_JSVAL(tmpobj=JSX_pointer_new_x(cx, 0, "'+parsed_code.typestring(obj)+'", '+currentdl+'));\n';
					ret+='JS_SetProperty(cx, tmpobj, "struct", &_structval);\n';
		            ret+='JS_SetProperty(cx, obj, "'+type.ident+'", &tmpval);\n';
				}
				testobj[type.ident]=true;
			}
		}
	} catch(x) {
		_.puts("ptr "+parsed_code.ptrs[index]);
		throw(x);
	}

	var evalstring="";
	for (var name in parsed_code.defs) try {
		var obj=parsed_code.defs[name];
		var macro=parsed_code.macro(obj);
		var intval=undefined;
		_resolve_disable=true;
		try {
			eval("with (testobj) {testobj[name]="+macro+"}");
			if (typeof(testobj[name])=="number" && (testobj[name]&0x3fffffff)==testobj[name]) {
				ret+='tmpval=INT_TO_JSVAL('+testobj[name]+');\n';
				ret+='JS_SetProperty(cx, obj, "'+name+'", &tmpval);\n';
			} else if (macro!==undefined && testobj[name]!==undefined) {
				evalstring+="this['"+name+"']="+macro+";\n";
			}
		} catch (x) {
//			var evalstring="try { with (this) { this['"+name+"']="+macro+" } } catch(x) { this['"+name+"']=undefined; }";
		}

	} catch(x) {
		print("def ",name,"\n");
		throw(x);
        } finally {
		_resolve_disable=false;
	}

	for (var name in parsed_code.typedefs) try {
		var obj=parsed_code.typedefs[name];
		var type=parsed_code.type(obj);
		if (type.dim.length==0 && type.type=="struct") {
			ret+='JS_GetProperty(cx, _struct, "'+type.struct_id+'", &tmpval);\n';
			ret+='JS_SetProperty(cx, obj, "'+name+'", &tmpval);\n';
		} else {
	                ret+='tmpval=OBJECT_TO_JSVAL(JSX_Type_new_x(cx, obj, 0, '+chopstring(parsed_code.typestring(obj))+'));\n';
        	        ret+='JS_SetProperty(cx, obj, "'+name+'", &tmpval);\n';
		}
	} catch(x) {
		print("types ",name,"\n");
		throw(x);
	}

	if (evalstring!="") {
		ret+="{ // MSVC can't compile long strings (65535 is one limit, there are others)\n";
		ret+="char *script=JS_malloc(cx,"+evalstring.length+");\n";
		ret+="if (script==0) return JS_FALSE;\n";
		var evalpos=0;
		while (evalstring.length>evalpos) {
			var len=evalstring.length-evalpos;
			if (len>4096) len=4096;
			ret+="memcpy(script+"+evalpos+","+chopstring(evalstring.substr(evalpos,len))+","+len+");\n";
			evalpos+=len;
		}
		ret+='JS_EvaluateScript(cx, obj, script, '+evalstring.length+', "init script", 1, rval);\n';
		ret+="JS_free(cx, script);\n";
		ret+="}\n";
	}

	foot+='return JS_TRUE;\n';
	foot+='}\n';

	return hdr+fw+ret+foot;

        function funcwrapper(name, obj, currentdl) {
		var ret='';
		ret+='struct JSX_pointer *JSCP_'+name+'=0;\n';
		ret+='JSBool JS_DLL_CALLBACK JSXC_'+name+'(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {\n';
		ret+='if (!JSCP_'+name+') JSCP_'+name+'=JSX_pointer_new_x_x(cx, obj, "'+parsed_code.typestring(obj)+'", '+currentdl+');\n';
		ret+='return JSX_pointer_call_x(cx, obj, JSCP_'+name+', argc, argv, rval);\n';
		ret+='}\n\n';
		return ret;
        }

	function chopstring(str) {
		if (str=="") return "";
		var ret='';
		while (str.length) {
			var strpart=str.substr(0,75);
			if (strpart.indexOf("\n")!=-1) strpart=strpart.substr(0,strpart.indexOf("\n")+1);
			ret+='"'+strpart.replace(/\\/g,'\\\\').replace(/"/g,'\\"').replace(/\n/g,'\\n')+'"\n';
			str=str.substr(strpart.length);
		}
		return ret;
	}
}

