module.include("readline");

console=function(Options) {
	if (Options!=undefined) {
		for (var i in this.Options)
			if (Options[i]==undefined)
				Options[i]=this.Options[i];
		this.Options=Options;
	}

	if (this.Options.histfile!=undefined)
		_.read_history(this.Options.histfile);

}

console.open=function(Options) {
	return new console(Options);
}

/**/

// used by open.js

console.open_uri=function(uri) {
	return this.open(uri.qry);
}

console.prototype.Options={
	prompt: "> ",
	histfile: undefined
}

console.prototype.readline=function() {
	_.fflush(_.stdout.get());
	_.fflush(_.stderr.get());
	var line=_.readline(this.Options.prompt);
	if (line==null) {
		this.close();
		return;
	}
	var ret=line.string();
	if (ret!="") _.add_history(line);
	_.free(line);
	return ret;
}

console.prototype.write=function(str) {
	print(str);
}

console.prototype.close=function() {
	if (!this.closed) {
		if (this.Options.histfile!=undefined)
			_.write_history(this.Options.histfile);
		print("\n");
		this.closed=true;
	}
}

console.prototype.closed=false;

console.prototype.eof=function() {
	return this.closed;
}
