/*
====open(uri, [...])====

Opens and returns the resource identified by ''uri''. Interprets the protocol as the name of a class.
Calls that classes' open_uri method with the decoded uri (http.decode_uri) as the first argument.
Any additional arguments are passed on to open_uri. Among the recognized protocols:

* [[file]]:///path (''mode'' and ''bufsize'' are optional additional arguments)
* [[mysql]]://[user[:password]]@[host]/[database][?[unix_socket=...][&clientflag=...]]
* [[cdb]]:///path (''mode'' is optional additional argument)


*/

function open(uri) {
	uri=http.decode_uri(uri);

	var clas=global[uri.protocol];
	return clas.open_uri.apply(clas, arguments);
}

