#ifdef _WIN32
#define _DLL
#endif

#include <stdio.h>
#include <stdlib.h>
#ifdef _WIN32
#include <io.h>
#include <direct.h>
#else
#include <unistd.h>
#include <sys/statvfs.h>
#include <pwd.h>
#include <sys/select.h>
#include <sys/errno.h>
#include <sys/ioctl.h>
#include <sys/times.h>
#include <sys/utsname.h>
#include <dirent.h>
#include <wait.h>
#endif
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <errno.h>

#ifdef _WIN32
#pragma JSEXT dl "MSVcrt.dll"
#else
#pragma JSEXT dl main  // Functions are found within main binary executable
#endif

// These functions need a wrapper, as they are sometimes inlined

#ifdef _WIN32
__declspec(dllexport) FILE *getstdin(void);
__declspec(dllexport) FILE *getstdout(void);
__declspec(dllexport) FILE *getstderr(void);
#else
int call_stat(const char *file_name, struct stat *buf);
int call_fstat(int filedes, struct stat *buf);
int call_lstat(const char *file_name, struct stat *buf);
int call_mknod(const char *pathname, mode_t mode, dev_t dev);
#endif

#pragma JSEXT dl default // Functions are found in clib.c

