module.include('readline');

/*
====raw_input(String prompt) -> String====

Uses the readline library, if available, or else fgets,
to read a line of input from the user. Returns line as
string, excluding newline character

*/

function raw_input(prompt) {

	if (typeof(_.readline)!="undefined") {
		var line=_.readline(prompt);
		if (line==null) throw(true);
		var linestring=line.string();
		_.free(line);
	} else {
		if (arguments.length>0) {
			_.fputs(prompt, _.stdout.get());
			_.fflush(_.stdout.get());
		}
		var buf=new Pointer(512);
		_.fgets(buf, 512, _.stdin.get());
		var linestring=buf.string();
	}

	return linestring;	
}

