function stringfile(str) {
	this.str=str;
	this.where=0;
	this.closed=false;
	this.name="string";
}

stringfile.prototype.closed=true;

stringfile.prototype.close=function() {
	if (!this.closed) {
		delete this.string;
		this.closed=true;
	}
}

stringfile.prototype.eof=function() {
	return this.where>=this.str.length;
}

stringfile.prototype.read=function(size) {
	if (arguments.length<1) size=-1;
	if (size<0) {
		var ret=this.str.substr(this.where);
		this.where=this.str.length;
	} else {
		var ret=this.str.substr(this.where,size);
		this.where+=size;
	}
	return ret;
}

stringfile.prototype.readline=function() {
	var nextpos=this.str.indexOf('\n',this.where);
	if (nextpos==-1) return this.read();

	var ret=this.str.substr(this.where, nextpos-this.where+1);
	this.where=nextpos+1;
	return ret;
}

stringfile.prototype.readlines=function() {
	var ret=[];
	while (!this.eof()) {
		ret.push(this.readline());
	}
	return ret;
}

stringfile.SEEK_SET=0;
stringfile.SEEK_CUR=1;
stringfile.SEEK_END=2;

stringfile.prototype.seek=function(offset, whence) {
	if (arguments.length<2) whence=this.SEEK_SET;

	switch(whence) {
	case stringfile.SEEK_SET:
		this.where=offset; break;
	case stringfile.SEEK_CUR:
		this.where+=offset; break;
	case stringfile.SEEK_END:
		this.where=this.str.length+offset; break;
	}
}

stringfile.prototype.tell=function() {
	return this.where;
}

stringfile.prototype.truncate=function(size) {
	if (arguments<1) size=-1;
	if (size<0) size=this.where;
	this.str=substr(this.str,0,size);
}

stringfile.prototype.write=function(str) {
	if (this.eof()) {
		this.str+=str;
	} else {
		this.str=this.str.substr(0,this.where)+str+this.str.substr(this.where+str.length);
	}
	where+=str.length;
}

stringfile.prototype.writelines=function(obj) {
	this.write(obj.join(""));
}


