/*
C.call(C,"#include <usb.h>","usb.so");
dl("libusb.so");

*/

_.usb_init();

function usb() {
	
}

/*
====get_string(index, [langid, [trylen]])====
*/

usb.prototype.get_string=function(index, langid, maxlen) {
	if (maxlen==undefined) {
		trylen=256;
		do {
			trylen*=2;
			var ret=this.get_string(index, langid, trylen);
		} while (ret.length==trylen);
		return ret;
	}
	buf=new Pointer(maxlen);
	if (langid==undefined) {
		var len=usb_get_string_simple(this.dev, index, buf, maxlen);
	} else {
		var len=usb_get_string(this.dev, index, langid, buf, maxlen)
	}
	return buf.string(len);
}

usb.prototype.reset=function() {
	var ret=_.usb_reset(this.dev);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.prototype.ep=function(ep) {
	var ret=new usb.epclass(this.dev,ep);
}

usb.epclass=function(dev, ep) {
	this.dev=dev;
	this.ep=ep;
}

usb.epclass.prototype.reset=function() {
	var ret=_.usb_resetep(this.dev, this.ep);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.epclass.prototype.clear_halt=function() {
	var ret=_.usb_clear_halt(this.dev, this.ep);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.epclass.prototype.write=function(str, timeout) {
	if (timeout==undefined) timeout=0;
	return _.usb_bulk_write(this.dev, this.ep, str, str.string, timeour);
}

usb.epclass.prototype.read=function(maxlen, timeout) {
	if (timeout==undefined) timeout=0;
	if (maxlen==undefined && timeout==0) {
		var trylen=256;
		var ret="";
		do {
			trylen*=2;
			var lastpart=this.read(trylen,0);
			ret+=lastpart;
		} while (lastpart.length==trylen);
		return ret;
	}
	var buf=new Pointer(maxlen);
	var len=_.usb_bulk_read(this.dev, this.ep, buf, maxlen, timeour);
	return buf.string(len);
}

usb.prototype.close=function() {
	var ret=_.usb_close(this.dev);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.prototype.open=function(dev) {
	this.dev=_.usb_open(dev);
}

usb.prototype.control_msg=function(requesttype, request, value, index, str, timeout) {
	if (timeout==undefined) timeout=0;
	var ret=_.usb_control_msg(this.dev, requesttype, request, value, index, str, str.length, timeout);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.prototype.set_configuration=function(configuration) {
	var ret=_.usb_set_configuration(this.dev, configuration);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.prototype.claim_interface=function(interfce) {
	var ret=_.usb_claim_interface(this.dev, interfce);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.prototype.release_interface=function(interfce) {
	var ret=_.usb_release_interface(this.dev, interfce);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.prototype.set_altinterface=function(alternate) {
	var ret=_.usb_set_altinterface(this.dev, alternate);
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.prototype.device=function() {
	return _.usb_device(this.dev);
}

usb.set_debug=function(level) {
	_.usb_set_debug(level);
}

usb.find_busses=function() {
	var ret=_.usb_find_busses();
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.find_devices=function() {
	var ret=_.usb_find_devices();
	if (ret<0) throw("usb: "+_.usb_strerror().string());
}

usb.get_busses=function() {
	return _.usb_get_busses();
}