/*
* Copyright (c) 2006, Berges Allmenndigitale Rdgivningstjeneste
* All rights reserved.
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of Berges Allmenndigitale Rdgivningstjeneste nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE BERGES AND CONTRIBUTORS ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL THE BERGES AND CONTRIBUTORS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef C_TO_JS_H
#define C_TO_JS_H

#include "../js/src/jsapi.h"
#include "type.h"

size_t JSX_C_to_JS_multi(JSContext * cx, JSObject * this,
			  char *argbuf, struct JSX_type **C, int nArgs_C, jsval *v, int nArgs_v, int do_clean, int align);
int JSX_contains_pointers(struct JSX_type *C);
JSBool JSX_ptr(JSContext *cx, JSObject *obj, char *C_var, struct JSX_type *C, jsval *v);
size_t JSX_unknown_array_to_JS(JSContext *cx, JSObject *obj,
				char *C_var,
				JSObject *array, int do_clean, char *oldptr);
size_t JSX_known_array_to_JS(JSContext *cx, JSObject *obj,
			      char *C_var, struct JSX_type *C,
			      JSObject *array, int do_clean, char *oldptr);
size_t JSX_C_to_JS(JSContext *cx, JSObject *obj, 
		    char *C_var,
		    struct JSX_type *C,
		    jsval *v,
		    int do_clean, char *oldptr);

#endif
