/*
* Copyright (c) 2006, Berges Allmenndigitale Rdgivningstjeneste
* All rights reserved.
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of Berges Allmenndigitale Rdgivningstjeneste nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE BERGES AND CONTRIBUTORS ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL THE BERGES AND CONTRIBUTORS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef POINTER_H
#define POINTER_H

#ifdef WIN32
# include <windows.h>
#endif

#include "../js/src/jsapi.h"
#include "js_to_c2.h"
#include "c_to_js2.h"

struct JSX_pointer {
  void *ptr;
  struct JSX_type *type;
  struct JSX_callback *callback;
};

int JSX_callback_exec(int retadr, int arg0);

#ifndef DLLACCESS
#ifdef _WIN32
#ifdef BUILD_POINTER_C
#define DLLACCESS __declspec(dllexport)
#else
#define DLLACCESS __declspec(dllimport)
#endif
#else
#define DLLACCESS
#endif
#endif

JSBool DLLACCESS JS_DLL_CALLBACK JSX_pointer_call_x(JSContext *cx, JSObject *obj, struct JSX_pointer *ptr, uintN argc, jsval *argv, jsval *rval);
JSObject DLLACCESS *JSX_pointer_new_x(JSContext *cx, JSObject *object, char *s, JSObject *dl);
struct JSX_pointer DLLACCESS *JSX_pointer_new_x_x(JSContext *cx, JSObject *object, char *s, JSObject *dl);
void DLLACCESS *JSX_globalsym(JSContext *, JSObject *dl, const char *symbol);

extern JSObject *JSX_pointer_proto;
extern JSClass JSX_pointer_class;
JSBool JS_DLL_CALLBACK JSX_pointer_toNumber(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_toString(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_member(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_new(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_apply(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_call(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_get(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_set(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_string(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_UCString(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_sizeof(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_type(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool JS_DLL_CALLBACK JSX_pointer_add(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
//JSBool JS_DLL_CALLBACK JSX_pointer_toString(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
void JS_DLL_CALLBACK JSX_pointer_finalize(JSContext *cx, JSObject *obj);
void JS_DLL_CALLBACK JSX_struct_finalize(JSContext *cx, JSObject *obj);
void JS_DLL_CALLBACK JSX_pointer_init(JSContext *cx, JSObject *obj);
void JS_DLL_CALLBACK JSX_struct_init(JSContext *cx, JSObject *obj);
JSBool JS_DLL_CALLBACK JSX_struct_toString(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
struct JSX_pointer *JSX_pointer_settype(JSContext *cx, JSObject *this, struct JSX_pointer *p, struct JSX_type *T);

#endif
